#!/bin/sh

echo "**********************************************************************"
echo "*                                                                    *"
echo "*        << The start of the installation of InterAct Ver1.0 >>      *"
echo "*                                                                    *"
echo "*   The flow of installation is as follows.                          *"
echo "*                                                                    *"
echo "*   Stage1. Execute this shell for creating user account of InterAct *"
echo "*           and copying the objects for insallation.                 *"
echo "*   Stage2. Carry out the basic setup of InterAct                    *"
echo "*           from your web browser.                                   *"
echo "*   Stage3. Copy the data for the address reference                  *"
echo "*           into the database of InterAct.                           *"
echo "*                                                                    *"
echo "*   In addition ,it is necessary to build the basic environment of   *"
echo "*   the server computer beforehand for performing the installation.  *"
echo "*   Please refer to the installation manual for details.             *"
echo "*                                                                    *"
echo "**********************************************************************"
echo ""

while true; do
	echo -n "the installation of InterAct will be started. all right ? (yes/no) -> "
	read answer
	if [ -z $answer ]; then
		echo "Please answer [yes] or [no]."
	elif [ $answer = yes ]; then
		break
	elif [ $answer = no ]; then
		echo "The installation of InterAct quit."
		exit 0
	fi
done

echo  ""
while true; do
	echo "Please specify the DocumentRoot of the web server."
	echo -n "( An initial value is [/usr/local/apache/htdocs]) -> "
	read docroot
	if [ -z $docroot ]; then
		docroot=/usr/local/apache/htdocs
	fi
	if [ -d "$docroot" ];then
		break
	else
		echo  ""
		echo "Directory not found. Please retry!"
		echo  ""
	fi
done
docroot=${docroot%/}

echo  ""
echo "Please specify the execution user of the web server."
echo -n "( An initial value is [nobody]) -> "
read web_user
if [ -z $web_user ]; then
	web_user=nobody
fi

echo  ""
echo "Please specify the execution group of the web server."
echo -n "( An initial value is [nobody]) -> "
read web_group
if [ -z $web_group ]; then
	web_group=nobody
fi

echo ""
echo "the user account named [interact] for installation of [InterAct] will be created."
useradd interact > /dev/null 2> /dev/null

echo ""
echo "the copy of the programs is started."
cp -r interact "$docroot"/interact > /dev/null 2> /dev/null
chown -R interact:interact "$docroot"/interact > /dev/null 2> /dev/null
chmod 755 "$docroot"/interact > /dev/null 2> /dev/null
chmod 755 "$docroot"/interact/configs > /dev/null 2> /dev/null
if ! chown -R "$web_user":"$web_group" "$docroot"/interact/data > /dev/null 2> /dev/null
then
	echo ""
	echo "Causion ! The processing error occurred."
	echo " Set-up the execution user or execution group of a Web server does not exist."
	echo "    The set-up execution user -> $web_user"
	echo "    The set-up execution group -> $web_group"
	echo " The installation of InterAct quit."
	exit 1
fi
chmod -R 755 "$docroot"/interact/data > /dev/null 2> /dev/null

chown "$web_user":"$web_group" "$docroot"/interact/configs/dbconnect.conf
chmod 644 "$docroot"/interact/configs/dbconnect.conf

echo ""
echo ""
echo "**********************************************************************"
echo "*                                                                    *"
echo "*   Stage 1 of the installation is completed.                        *"
echo "*   Please carry out Stage 2 from your web browser continuously.     *"
echo "*                                                                    *"
echo "*   URL is                                                           *"
echo "*     http://[Server Name or IPaddress]/interact/install/index.htm   *"
echo "*                                                                    *"
echo "**********************************************************************"
exit 0
